From fd6847a4ec18e5bbe64b699346b55f332d59939d Mon Sep 17 00:00:00 2001
From: Nick Steel <nick@nsteel.co.uk>
Date: Mon, 20 Jun 2022 23:18:20 +0100
Subject: [PATCH 07/21] Remove pyspotify: dictinct part 2

---
 mopidy_spotify/distinct.py | 15 ++++++++++-----
 tests/test_distinct.py     | 20 ++++++++++++++++----
 2 files changed, 26 insertions(+), 9 deletions(-)

diff --git a/mopidy_spotify/distinct.py b/mopidy_spotify/distinct.py
index 61c254f0..abecff0c 100644
--- a/mopidy_spotify/distinct.py
+++ b/mopidy_spotify/distinct.py
@@ -9,6 +9,7 @@ def get_distinct(config, playlists, web_client, field, query=None):
     # To make the returned data as interesting as possible, we limit
     # ourselves to data extracted from the user's playlists when no search
     # query is included.
+    # TODO: Perhaps should use tracks from My Music instead?
 
     if field == "artist":
         result = _get_distinct_artists(config, playlists, web_client, query)
@@ -53,9 +54,10 @@ def _get_distinct_albumartists(config, playlists, web_client, query):
         }
     else:
         return {
-            track.album.artist.name
+            artists.name
             for track in _get_playlist_tracks(config, playlists, web_client)
-            if track.album and track.album.artist
+            for artists in track.album.artists
+            if track.album and track.album.artists
         }
 
 
@@ -87,9 +89,9 @@ def _get_distinct_dates(config, playlists, web_client, query):
         }
     else:
         return {
-            f"{track.album.year}"
+            f"{track.album.date}"
             for track in _get_playlist_tracks(config, playlists, web_client)
-            if track.album and track.album.year not in (None, 0)
+            if track.album and track.album.date not in (None, 0)
         }
 
 
@@ -113,4 +115,7 @@ def _get_playlist_tracks(config, playlists, web_client):
         return
 
     for playlist_ref in playlists.as_list():
-        yield from playlist.get_items(playlist_ref.uri)
+        playlist = playlists.lookup(playlist_ref.uri)
+        if playlist:
+            for track in playlist.tracks:
+                yield track
diff --git a/tests/test_distinct.py b/tests/test_distinct.py
index afc98b4a..822b11e6 100644
--- a/tests/test_distinct.py
+++ b/tests/test_distinct.py
@@ -3,7 +3,7 @@
 import pytest
 from mopidy import models
 
-from mopidy_spotify import distinct, search
+from mopidy_spotify import distinct, search, playlists
 
 
 @pytest.fixture
@@ -11,13 +11,13 @@ def web_client_mock_with_playlists(
     web_client_mock,
     web_playlist_mock,
 ):
-
     web_client_mock.get_user_playlists.return_value = [
         web_playlist_mock,
         {},
         web_playlist_mock,
     ]
-    return session_mock
+    web_client_mock.get_playlist.return_value = web_playlist_mock
+    return web_client_mock
 
 
 @pytest.fixture
@@ -44,16 +44,28 @@ def test_get_distinct_unsupported_field_types_returns_nothing(provider, field):
         ("artist", {"ABBA"}),
         ("albumartist", {"ABBA"}),
         ("album", {"DEF 456"}),
-        ("date", {"2001"}),
     ],
 )
+# ("date", {"2001"}),
 def test_get_distinct_without_query_when_playlists_enabled(
     web_client_mock_with_playlists, provider, field, expected
 ):
+    provider._backend.playlists = playlists.SpotifyPlaylistsProvider(backend=provider._backend)
+    provider._backend.playlists._loaded = True
 
     assert provider.get_distinct(field) == expected
 
 
+def test_get_distinct_without_query_returns_nothing_when_playlists_empty(
+    web_client_mock_with_playlists, provider
+):
+    provider._backend.playlists = playlists.SpotifyPlaylistsProvider(backend=provider._backend)
+    provider._backend.playlists._loaded = True
+    web_client_mock_with_playlists.get_playlist.return_value = {}
+
+    assert provider.get_distinct("artist") == set()
+
+
 @pytest.mark.parametrize("field", ["artist", "albumartist", "album", "date"])
 def test_get_distinct_without_query_returns_nothing_when_playlists_disabled(
     provider, config, field

